/*
 * Dynamic Particle System Library (DPSl)
 * Version:  1.0
 *
 * Universidade do Minho 2000/2001
 * Licenciatura em Engenharia de Sistemas e Informatica - LESI
 *
 * Jose Miguel Araujo Ferreira (jmaferreira@hotmail.com)
 * Pedro Gabriel Ferreira      (pgabiferreira@portugalmail.pt)
 * Rui Manuel A. R. S. Guerra  (ruiguerra@hotmail.com)
 *
 */

#include "dps_demo.h"

#define TIME_INCREMENT 0.8


DPSshandle pset;
DPSshandle fset;
DPSshandle oset;
float sim_time = 0;


float simulation_time() {
  return sim_time;
}


unsigned int live_particles() {
  return dpsLiveParticles(pset);
}




void dps_init() {
  pset = dpsGenParticleSystem(1);
  fset = dpsGenForceSystem(1);
  oset = dpsGenObjectSystem(1);
  

  dpsNewForceSystem(fset);
    dpsNewKillOld(250.0f, DPS_FALSE);
    dpsNewTargetColor(1.0, 1.0, 1.0, 0.0, 0.005);
  dpsEndForceSystem();


  dpsColor3f(0.0f, 0.0f, 0.0f);

  dpsNewObjectSystem(oset);
    dpsNewDisc(0.0f, 0.0f, -40.0f, 0.00f, 0.0f, 1.0f, 0.0, 70.0f, DPS_SOURCE, 12.0f, 0.7f, 0.5f);
  dpsEndObjectSystem();



  dpsTimeIncrementf(TIME_INCREMENT);
}








void dps_iterate() {
  dpsIterateParticles(pset, fset, oset);
  sim_time += TIME_INCREMENT;
}





void dps_display() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  dpsDrawParticleSystem(DPS_LINES | DPS_COLOR, pset);
}


