/*
 * Dynamic Particle System Library (DPSl)
 * Version:  1.0
 *
 * Universidade do Minho 2000/2001
 * Licenciatura em Engenharia de Sistemas e Informatica - LESI
 *
 * Jose Miguel Araujo Ferreira (jmaferreira@hotmail.com)
 * Pedro Gabriel Ferreira      (pgabiferreira@portugalmail.pt)
 * Rui Manuel A. R. S. Guerra  (ruiguerra@hotmail.com)
 *
 */

#include "dps_demo.h"

#define TIME_INCREMENT 1.2


DPSshandle pset;
DPSshandle fset;
DPSshandle oset;
float sim_time = 0;


float simulation_time() {
  return sim_time;
}


unsigned int live_particles() {
  return dpsLiveParticles(pset);
}




void dps_init() {
  pset = dpsGenParticleSystem(1);
  fset = dpsGenForceSystem(1);
  oset = dpsGenObjectSystem(1);
  

  dpsNewForceSystem(fset);
    dpsNewGravity(0.0f, -0.1f, 0.0f);
    dpsNewKillOld(200.0f, DPS_FALSE);
  dpsEndForceSystem();



  dpsColor3f(0.0f, 0.7f, 0.8f);
  dpsRGBADev(0.0f, 0.3f, 0.2f, 0.0f);


  dpsNewObjectSystem(oset);
    dpsNewDisc(-5.0, 60.0, -60.0, 1, 1, 0, 0.0, 2.0, DPS_SOURCE, 20.0, 1, 0.2);
    
    dpsNewPlane(0.0, -30.0, 0.0, 
                -0.5, 0.5, 0.05, 
                DPS_COLLIDE, 0.7, 0.5, 6.0);
                
    dpsNewPlane(0.0, -30.0, 1.0, 
                0.5, 0.5, 0.05, 
                DPS_COLLIDE, 0.7, 0.5, 6.0);
                
  dpsEndObjectSystem();



  dpsTimeIncrementf(TIME_INCREMENT);
}








void dps_iterate() {
  dpsIterateParticles(pset, fset, oset);
  sim_time += TIME_INCREMENT;
}





void dps_display() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  dpsDrawParticleSystem(DPS_LINES | DPS_COLOR, pset);
}


